//----------------------------------------------------------------------------
// C main line
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include "stdlib.h"

int iResult;
double dResult;
const double scaleFactor = 0.0012315996074583;
char* buf;
void main(void)
{
	LCD_Start();
	LCD_Position(0,0);
	LCD_PrCString("Measured Voltage");
	
	UART_Start(UART_PARITY_NONE); 
	PGA_Start(PGA_HIGHPOWER);			//запуск PGA
	ADCINC12_Start(ADCINC12_HIGHPOWER);	//запуск АЦП
	ADCINC12_GetSamples(0);				//установка АЦП на песперерывную работу
	M8C_EnableGInt ; // Uncomment this line to enable Global Interrupts
	while(1) 		// главный цикл прошивки
	{
		if (ADCINC12_fIsDataAvailable() != 0)	//проверка на данных в ADC	
		{
			iResult = ADCINC12_iGetData() +2048;	
			ADCINC12_ClearFlag();			
			dResult = iResult * scaleFactor;
			LCD_Position(1,0);					//установка позиции для вывода
			buf = ftoa(dResult,0);
			LCD_PrString(buf);
			UART_PutString(buf);
			UART_PutChar('\n');
			//UART_PutCRLF();
		}
	}
	// Insert your main routine code here.
}
